'' needed headers
#Include "string.bi"
#Include Once "object.bas"
#Include Once "route.bi"
#Include Once "sectors.bi"
Randomize Timer*100
Dim Shared As EventHandle Ptr event
event=New EventHandle
Dim Shared As Integer minimum_bs,maximum_bs,minimum_bo,maximum_bo,pagesize,minimum_arms,maximum_arms
Dim Shared As Single minimum_k,maximum_k,minimum_p,maximum_p

minimum_bs=1
maximum_bs=127
minimum_bo=0
maximum_bo=32
minimum_k=35
maximum_k=100
minimum_p=5
maximum_p=15
minimum_arms=1
maximum_arms=9
pagesize=1
Dim Shared As Gadget Ptr ScrollBulgeSize
Dim Shared As Gadget Ptr ScrollBulgeOffset
Dim Shared As Gadget Ptr ScrollSpiralK
Dim Shared As Gadget Ptr ScrollSpiralP
Dim Shared As Gadget Ptr ScrollSpiralArms
Dim Shared As Gadget Ptr ScrollBulgeHeight
Dim Shared As Gadget Ptr FlyButton
FlyButton=AddSimpleGadget(event,166,scrH-150+122,170,20,"Generate and Fly")

ScrollBulgeSize= AddScrollBar(event,150,scrH-150+0,200,minimum_bs,maximum_bs,1,pagesize,0)
SetScrolLBarVal(ScrollBulgeSize,320)
ScrollBulgeOffset= AddScrollBar(event,150,scrH-150+20,200,minimum_bo,maximum_bo,0,pagesize,0)
SetScrolLBarVal(ScrollBulgeoffset,0)
ScrollSpiralK= AddScrollBar(event,150,scrH-150+60,200,minimum_k,maximum_k,1,pagesize,0)
SetScrolLBarVal(ScrollSpiralK,35)
ScrollSpiralP= AddScrollBar(event,150,scrH-150+80,200,minimum_p,maximum_p,1,pagesize,0)
SetScrolLBarVal(ScrollSpiralP,5)
ScrollSpiralArms= AddScrollBar(event,150,scrH-150+100,200,minimum_arms,maximum_arms,1,pagesize,0)
SetScrolLBarVal(ScrollSpiralArms,1)
ScrollBulgeHeight= AddScrollBar(event,150,scrH-150+40,200,1.0,40.0,1,pagesize,0)
SetScrolLBarVal(ScrollBulgeHeight,20)

Dim Shared line_pattern(0 To 15) As UShort={&b0000000011111111,&b0000000111111110,&b0000001111111100,&b0000011111111000,&b0000111111110000,&b0001111111100000,&b0011111111000000,&b0111111110000000,&b1111111100000000,&b1111111000000001,&b1111110000000011,&b1111100000000111,&b1111000000001111,&b1110000000011111,&b1100000000111111,&b1000000001111111}



Declare Sub sortList(list As arrayList)
	Declare Sub generate_sectors(n As node_t Ptr,epoch As double)

Type connection_t
	dist As Double
	node_1 As UInteger
	node_2 As UInteger
	Declare Constructor ()
	declare constructor( byval d as Double,n1 As UInteger,n2 As uinteger )
	Declare Destructor ()
End Type
constructor connection_t()
dist = 0
node_1=0
node_2=0
End constructor

Constructor connection_t( byval d as Double,n1 As UInteger,n2 As uinteger )
dist = d
node_1=n1
node_2=n2
End constructor

Destructor connection_t()
End Destructor
'
'Dim Shared con As connection_t Ptr
'Dim Shared As arrayList connectionList_tmp
'Dim Shared As arrayList connectionList
'
'


'Function get_distance(n1 As node_t, n2 As node_t) As Double
'	Return Sqr( (n2.posi.x-n1.posi.x)*(n2.posi.x-n1.posi.x) + (n2.posi.y-n1.posi.y)*(n2.posi.y-n1.posi.y) + (n2.posi.z-n1.posi.z)*(n2.posi.z-n1.posi.z) )
'End Function
'Function calcConnectionCount(num_nodes As UInteger) As UInteger
'   Return (num_nodes*(num_nodes+1)/2) - num_nodes' See http://de.wikipedia.org/wiki/Der_kleine_Gau%C3%9F
'End Function


Type galaxy_t
	Declare Constructor()
	Declare Constructor(seed As uinteger)
	Declare Constructor(filename As string)
	Declare Destructor()

	Declare Sub set_seed(s As UInteger)
	Declare Sub regenerate()
	Declare Sub generate_MST(cam As cameras)
	Declare Sub get_path(s As UInteger, t As uinteger)
	Declare Sub render_model(cam As cameras)
	Declare Sub pre_render_model(cam As cameras)
	Declare Sub render_path(cam As cameras)

	model As object3d Ptr
	path As object3d Ptr

	path_nodes As arrayList

	seed As UInteger
	
End Type
Destructor galaxy_t()

If path_nodes.count()>0 Then
	For i As UInteger=0 To path_nodes.count()-1
		path_nodes.removeLast()
	Next
EndIf
'path->destructor()
Print "here"
End Destructor
Constructor galaxy_t()

End Constructor
Constructor galaxy_t(seed As uinteger)
set_seed(seed)
model=New object3d()
path=New object3d()
regenerate()
End Constructor

Sub galaxy_t.set_seed(seed As UInteger)
	this.seed=seed
	Randomize seed
End Sub

Sub galaxy_t.regenerate()
	'' if there are vertices on the object, release them
	if( model->vertices->count > 0 ) then
		for i as integer = 0 to model->vertices->count - 1
			model->vertices->removeLast()
		next
	end if

	'' same for the edges

	if( model->edges->count > 0 ) then
		for i as integer = 0 to model->edges->count - 1
			model->edges->removeLast()
		next
	end If
	set_seed(this.seed)

	Color &hffffffff,&h00

	Dim count As UInteger=0
	Dim x As Double
	Dim y As Double
	Dim z As Double
	Dim nr_arms As UInteger=GetScrollBarVal(ScrollSpiralArms)
	model->vertices->Add( New vec4( 0,0,0 ))
	For j As UInteger=0 To 360-360/nr_arms Step 360/nr_arms
		'count+=1
		For i As Single=0 To 1440 Step 1
			Dim As Single k=GetScrollBarVal(ScrollSpiralK)/10.0
			Dim As Single p=GetScrollBarVal(ScrollSpiralP)/10.0
			Dim r1 As Single=(((i^2)/(k/p)^4))
			If r1>=5.0 Then Exit For
			y=0
			x=0
			z=0
			For s As Single=0 To sigmoid(map(r1,0,10,0,-16),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*3 Step nr_arms
				Dim p1 As vec4
				x=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10'
				z=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10'
				y=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10
				p1.y=y*3.0
				p1.x=Sin((i+j)*degToRad)*r1*10.0+x*3.0
				p1.z=Cos((i+j)*degToRad)*r1*10.0+z*3.0

				'galaxy_tmp->vertices->Add( New vec4( p1.x, p1.y, p1.z ) )
				model->vertices->Add( New vec4( p1.x, p1.y, p1.z ))
				For s1 As single=0 To (sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 ))*1 Step 1
					x=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10'
					z=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10'
					y=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*GetScrollBarVal(ScrollBulgeHeight)/10
					p1.y+=y*1.5
					p1.x+=x*1.5
					p1.z+=z*1.5
					model->vertices->Add( New vec4( p1.x, p1.y, p1.z ))
					'					drawPoint3d(cam,vec4( p1.x, 0, p1.z ),sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*320.0,c)
					count+=1
				Next
			Next
		Next
	Next

End Sub
Sub galaxy_t.generate_MST(cam As cameras)
	Color &hffffffff



	Dim vert1_ptr As arrayList Ptr=model->vertices()
	Dim vert2_ptr As arrayList Ptr=model->vertices()
	Dim con As connection_t Ptr
	Dim As arrayList connectionList_tmp
	Dim As arrayList connectionList


	Dim As UInteger from_counter_max=((model->vertices->count-2))'*(galaxy_tmp->vertices->count)/2)-(galaxy_tmp->vertices->count-1)'(STARS*(STARS+1)/2) - STARS
	Dim As UInteger from_counter'=from_counter_max
	Dim As UInteger to_counter'=galaxy_tmp->vertices->count-1
	Dim dist As Double
	Dim vert1 As vec4 Ptr
	Dim vert2 As vec4 Ptr
	Dim As connection_t Ptr con1
	Dim id1 As UInteger
	Dim id2 As UInteger
	Dim counter As uinteger=0

	'generate distance array
	Print "generate distance array"
	For i As UInteger=0 To model->vertices->count()-1
		'Locate 1,1
		'Print i/galaxy_tmp->vertices->count()*100
		vert1 = vert1_ptr->Get(i)
		For j As UInteger=i To model->vertices->count()-1
			vert2 = vert1_ptr->Get(j)
			dist=distance3d(vert2->x,vert2->y,vert2->z,vert1->x,vert1->y,vert1->z)
			If i<>j And dist<=(GetScrollBarVal(ScrollBulgeHeight)/10+GetScrollBarVal(ScrollBulgeHeight)/100)*2 Then
				con=New connection_t(dist,i,j)
				connectionList.Add(con)
			EndIf
		Next
	Next
	'generate spannbaum
	Print "generate MST"
	from_counter_max=connectionList.count()-1
	sortList(connectionList)
	While (to_counter<model->vertices->count-1)
		'	sortList(connectionList)
		'sort distance array
		Dim s As String="Generating MST: " & Format(1-((connectionList.count()/from_counter_max)),"000.00%")
		Dim si As UInteger=Len(s)*16
		Line(scrW/3,scrH-50)-(scrW/3+si,scrH-50+20),&hff000000,BF
		Line(scrW/3,scrH-50)-(scrW/3+map(connectionList.count()/from_counter_max,1.0,0.0,0.0,si),scrH-50+20),&hff3333ff,BF
		Line(scrW/3,scrH-50)-(scrW/3+si,scrH-50+20),&hffffffff,B
		Draw String(scrW/3+si\4,scrH-50+8),s,&hffffffff
		con1=connectionList.get(0)
		model->edges->add( new edge( vert1_ptr->Get(con1->node_1),vert1_ptr->Get(con1->node_2) ) )
		counter=0
		id1 =con1->node_1
		id2 =con1->node_2
		dist=con1->dist
		While (counter<connectionList.count()-1)
			con1=connectionList.get(counter)
			If (con1->node_2=id2) Then 'And (con1->node_2<>id1)Then'Or (con1->node_2=id2)Then'and not(con1->node_1=id2) Then
				'			Print "here",to_counter,model->vertices->count-1,counter,from_counter_max
				connectionList.remove(counter)
				counter-=1
			EndIf
			counter+=1
		Wend
		to_counter+=1
		render_model(cam)
	Wend
	build_nodes(model,0,0)


End Sub

Sub galaxy_t.render_model(cam As cameras)
	Dim As UInteger cols(0 To 1)={&hff6666ff,&hffff6666}
	Dim r As UInteger=RGBA(127,127,255,64)
	If model->edges->count>0 Then

		dim as edge ptr e = model->edges->get( 0 )
		for j as integer = 0 to model->edges->count - 1
			e = model->edges->Get( j )
			Dim dist1 As Double=distance3d(0,0,0,e->vertex1->x,e->vertex1->y,e->vertex1->z)
			Dim dist2 As Double=distance3d(0,0,0,e->vertex2->x,e->vertex2->y,e->vertex2->z)
			Dim As UInteger col_s1=cols(Int(density(map(dist1,0,50,-4,4))+0.75))
			Dim As UInteger col_s2=cols(Int(density(map(dist2,0,50,-4,4))+0.75))
			'Print col_s2,Int(density(map(dist2,0,50,-4,4))+0.5),density(map(dist2,0,50,-4,4))+0.5
			'			drawPoint3d(cam,galaxy->objectSpaceToWorldSpace( *e->vertex1 ),10,&h336666ff)

			If e->vertex1->x=0 And e->vertex1->y=0 And e->vertex1->z=0 then
				'r=Temperature2RGB(Rnd*2000+2000+e->vertex2->distance(vec4(0,0,0))*100,127)
				'drawPoint3d(cam,model->objectSpaceToWorldSpace( *e->vertex1 ),10,&hffff0000)
				'drawPoint3d(cam,model->objectSpaceToWorldSpace( *e->vertex2 ),10,r)
				drawLine3d( cam, model->objectSpaceToWorldSpace( *e->vertex1 ), model->objectSpaceToWorldSpace( *e->vertex2 ), rgba( 255, 00, 00, 255 ),line_pattern(Int((Timer*10.0))Mod 16) )
			Else
				'drawPoint3d(cam,galaxy->objectSpaceToWorldSpace( *e->vertex1 ),10,col_s1)
				'		drawCircle3d(cam,galaxy->objectSpaceToWorldSpace( *e->vertex2 ),1,8,&h336666ff)
				'r=Temperature2RGB(Rnd*2000+2000+e->vertex2->distance(vec4(0,0,0))*100,127)
				'drawPoint3d(cam,model->objectSpaceToWorldSpace( *e->vertex2 ),10,r)
				drawLine3d( cam, model->objectSpaceToWorldSpace( *e->vertex1 ), model->objectSpaceToWorldSpace( *e->vertex2 ), rgba( 64, 64, 255, 255 ) ,line_pattern(Int((Timer*10.0))Mod 16))
			endif
		next
	EndIf
	
	dim as vec4 Ptr v
	Dim s As sector_t Ptr
	if( model->vertices->count > 0 ) then
		for i as integer = 0 to model->vertices->count-1
			v = model->vertices->get( i )
'			s=sector->Get(i)
			If v->x=0 And v->y=0 And v->z=0 Then
					'			r=Temperature2RGB(s->kelvin,32)

				drawPoint3d(cam,model->objectSpaceToWorldSpace( *v ),10,r)
			Else
							'	r=Temperature2RGB(s->kelvin,32)

				drawPoint3d(cam,model->objectSpaceToWorldSpace( *v ),10,r)
			EndIf
		next
	end If

End Sub

Sub galaxy_t.pre_render_model(cam As cameras)
	Dim r As uinteger
	If model<>0 Then
		dim as vec4 Ptr v
		if( model->vertices->count > 0 ) then
			for i as integer = 0 to model->vertices->count-1
				v = model->vertices->get( i )
				'				If MouseOver(cam,*v,200) Then Print "yes"
				If v->x=0 And v->y=0 And v->z=0 Then
					drawPoint3d(cam,model->objectSpaceToWorldSpace( *v ),200,&hffff0000)
				Else
					r=Temperature2RGB(Rnd*2000+2000+v->distance(vec4(0,0,0))*100,127)
					'r=Temperature2RGB(40000,255)
					drawPoint3d(cam,model->objectSpaceToWorldSpace( *v ),200,r)
				EndIf
			next
		end If
	endif
End Sub

Sub galaxy_t.get_path(s As UInteger, t As uinteger)
	Dim start As UInteger=s
	Dim ende As UInteger=t

End Sub








'Dim Shared As object3d Ptr galaxy
'galaxy=New object3d()
'
'Sub generate_galaxy(nr_arms As UInteger, k As Single, p As Single)
'
'	Dim count As UInteger=0
'	Dim x As Double
'	Dim y As Double
'	Dim z As Double
'	'Dim nr_arms As UInteger=GetScrollBarVal(ScrollSpiralArms)
'	galaxy->vertices->Add( New vec4( 0,0,0 ))
'	For j As UInteger=0 To 360-360/nr_arms Step 360/nr_arms
'		'count+=1
'		For i As Single=0 To 1440 Step 1
'			'Dim As Single k=GetScrollBarVal(ScrollSpiralK)/10.0
'			'Dim As Single p=GetScrollBarVal(ScrollSpiralP)/10.0
'			Dim r1 As Single=(((i^2)/(k/p)^4))
'			If r1>=5.0 Then Exit For
'			y=0
'			x=0
'			z=0
'			For s As Single=0 To sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*3 Step nr_arms
'				Dim p1 As vec4
'				x=(-0.5+Rnd)'*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )
'				z=(-0.5+Rnd)'*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )
'				y=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )
'				p1.y=y*3.0
'				p1.x=Sin((i+j)*degToRad)*r1*10.0+x*3.0
'				p1.z=Cos((i+j)*degToRad)*r1*10.0+z*3.0
'
'				'galaxy_tmp->vertices->Add( New vec4( p1.x, p1.y, p1.z ) )
'				galaxy->vertices->Add( New vec4( p1.x, p1.y, p1.z ))
'				For s1 As single=0 To (sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 ))*1 Step 1
'					x=(-0.5+Rnd)'*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )
'					z=(-0.5+Rnd)'*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )
'					y=(-0.5+Rnd)*sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )
'					p1.y+=y*1.5
'					p1.x+=x*1.5
'					p1.z+=z*1.5
'					galaxy->vertices->Add( New vec4( p1.x, p1.y, p1.z ))
'					'					drawPoint3d(cam,vec4( p1.x, 0, p1.z ),sigmoid(map(r1,0,10,0,-8),GetScrollBarVal(ScrollBulgeSize)/100.0,GetScrollBarVal(ScrollBulgeOffset)/100.0 )*320.0,c)
'					count+=1
'				Next
'			Next
'		Next
'	Next
'
'	Color &hffffffff
'
'
'	Dim vert1_ptr As arrayList Ptr=galaxy->vertices()
'	Dim vert2_ptr As arrayList Ptr=galaxy->vertices()
'
'	Dim As UInteger from_counter_max=((galaxy->vertices->count-2))'*(galaxy_tmp->vertices->count)/2)-(galaxy_tmp->vertices->count-1)'(STARS*(STARS+1)/2) - STARS
'	Dim As UInteger from_counter'=from_counter_max
'	Dim As UInteger to_counter'=galaxy_tmp->vertices->count-1
'	Dim dist As Double
'	Dim vert1 As vec4 Ptr
'	Dim vert2 As vec4 Ptr
'	Dim As connection_t Ptr con1
'	Dim id1 As UInteger
'	Dim id2 As UInteger
'	Dim counter As uinteger=0
'
'	'generate distance array
'	Print "generate distance array"
'	For i As UInteger=0 To galaxy->vertices->count()-1
'		'Locate 1,1
'		'Print i/galaxy_tmp->vertices->count()*100
'		vert1 = vert1_ptr->Get(i)
'		For j As UInteger=i To galaxy->vertices->count()-1
'			vert2 = vert1_ptr->Get(j)
'			dist=distance3d(vert2->x,vert2->y,vert2->z,vert1->x,vert1->y,vert1->z)
'			If i<>j Then
'				con=New connection_t(dist,i,j)
'				connectionList.Add(con)
'			EndIf
'		Next
'	Next
'	'generate spannbaum
'	from_counter_max=connectionList.count()-1
'	sortList(connectionList)
'	While (to_counter<galaxy->vertices->count-1)
'		'	sortList(connectionList)
'		'sort distance array
'		Line(100,100)-(100+200,100+20),&hff000000,BF
'		Line(100,100)-(100+map(connectionList.count()/from_counter_max,1.0,0.0,0.0,200.0),100+20),&hff3333ff,BF
'		Line(100,100)-(100+200,100+20),&hffffffff,B
'		Draw String(120,108),str(connectionList.count()/from_counter_max*100),&hffffffff
'		con1=connectionList.get(0)
'		galaxy->edges->add( new edge( vert1_ptr->Get(con1->node_1),vert1_ptr->Get(con1->node_2) ) )
'		counter=0
'		id1 =con1->node_1
'		id2 =con1->node_2
'		dist=con1->dist
'		While (counter<connectionList.count()-1)
'			con1=connectionList.get(counter)
'			If (con1->node_2=id2) Then 'And (con1->node_2<>id1)Then'Or (con1->node_2=id2)Then'and not(con1->node_1=id2) Then
'				connectionList.remove(counter)
'				counter-=1
'			EndIf
'			counter+=1
'		Wend
'		to_counter+=1
'	Wend
'End Sub

Sub quicksort(list As arrayList, l As Long, r As Long)
	Dim As connection_t Ptr con1,con2

	Dim As ULong size = r - l +1
	If size < 2 Then Exit Sub
	con1=list.get(l + size \ 2)

	Dim As Long i = l, j = r
	Dim As double pivot = con1->dist

	Do
		con1=list.get(i)
		While con1->dist < pivot
			i += 1
			con1=list.get(i)
		Wend
		con1=list.get(j)
		While pivot < con1->dist
			j -= 1
			con1=list.get(j)
		Wend
		If i <= j Then
			list.swapa(i,j)
			i += 1
			j -= 1
		End If
	Loop Until i > j

	If l < j Then quicksort(list, l, j)
	If i < r Then quicksort(list, i, r)

End Sub
Sub sortList(list As arrayList)
	'Print "sort distance array...",connectionList.count()-1
	quicksort(list,0,list.count-1)
	'	Print "sorting done."
End Sub




Sub generate_sectors(n As node_t Ptr,epoch As Double)
	Dim nr_systems As UInteger=1'n->connections.count
	'If nr_systems>0 Then
		'While nr_systems>0
		Dim s As sector_t Ptr=New sector_t(n->id)
		s->generate_systems(nr_systems)
		s->size=80*nr_systems
		'For i As UInteger=0 To nr_systems-1
			Dim sys As system_t ptr=s->systems->Get(0)
			For j As UInteger=0 To sys->nr_stars-1
				s->kelvin+=sys->star[j].temperature
			Next
			s->kelvin/=sys->nr_stars
		'Next
		s->epoch=epoch
		sectors->Add(s)
		'nr_systems-=1
		'Wend
	'EndIf
End Sub